Windows Installer

Windows Installer makes it easy for you to manage the software installation and removal process, and modify, repair, and advertise existing applications.

  • For help with specific tasks, see How to.
  • For general background information, see Concepts.
  • For problem-solving instructions, see Troubleshooting.


How to...

  • Use Windows Installer packages with Windows Explorer
  • Use Windows Installer packages with Add or Remove Programs
  • Use Windows Installer from the command line
  • Configure Group Policy for Windows Installer


Use Windows Installer packages with Windows Explorer

Microsoft Windows graphic

To use Windows Installer packages with Windows Explorer

  1. Open Windows Explorer.
  2. Right-click the Windows Installer package (.msi file), and then click Install, Repair, or Uninstall.

Note

  • XOX

Related Topics


Use Windows Installer packages with Add or Remove Programs

Microsoft Windows graphic

To use Windows Installer packages with Add or Remove Programs

  1. Open Add or Remove Programs in Control Panel.
  2. Click Change or Remove Programs, click the program that you want to change or remove, and then do one of the following:
    • To change a program, click Change.
    • To remove a program, click Remove.

Note

  • XOX

Related Topics


Use Windows Installer from the command line

  • Install a transform using the command line
  • Install and advertise a product using a transform at the command line
  • Install a package using the command line
  • Remove a package using the command line
  • Repair a package using the command line
  • Advertise a package using the command line
  • Create an administrative installation package from the command line
  • Create an installation log file using the command line


Install a transform using the command line

Microsoft Windows graphic

To install a transform using the command line

  1. Open Command Prompt.
  2. Type:

    msiexec /i package TRANSFORMS=TransformList

    Value | Description
    /i | Installs a product.
    package | Specifies the name of the Windows Installer package file.
    TRANSFORMS=TransformList | Specifies what transform (.mst) files should be applied to the package. TransformList is a list of paths separated by semicolons.

Notes

  • XOX
  • Windows Installer command-line options are not case-sensitive. For more information about msiexec command-line options, see Related Topics.

Related Topics


Install and advertise a product using a transform at the command line

Microsoft Windows graphic

To install and advertise a product using a transform at the command line

  1. Open Command Prompt.
  2. Type:

    msiexec package /j{u | m} /t TransformList

    Value | Description
    package | Specifies the name of the Windows Installer package file.
    /j | Advertises a product. This command-line option ignores any property values typed at the command line.
    u | Advertises to the current user.
    m | Advertises to all users of this computer.
    /t TransformList | Applies transform to advertised package and specifies what transform (.mst) files should be applied to the package. TransformList is a list of paths separated by semicolons.

Notes

  • XOX
  • Windows Installer command-line options are not case-sensitive. For more information about msiexec command-line options, see Related Topics.

Related Topics


Install a package using the command line

Microsoft Windows graphic

To install a package using the command line

  1. Open Command Prompt.
  2. Type:

    msiexec /i {package | ProductCode}

    Value | Description
    /i | Installs a product.
    package | Specifies the name of the Windows Installer package file.
    ProductCode | Specifies the globally unique identifier (GUID) of the Windows Installer package.

Notes

  • XOX
  • Windows Installer command-line options are not case-sensitive. For more information about msiexec command-line options, see Related Topics.

Related Topics


Remove a package using the command line

Microsoft Windows graphic

To remove a package using the command line

  1. Open Command Prompt.
  2. Type:

    msiexec /x {package | ProductCode}

    Value | Description
    /x | Uninstalls a product.
    package | Specifies the name of the Windows Installer package file.
    ProductCode | Specifies the globally unique identifier (GUID) of the Windows Installer package.

Notes

  • XOX
  • Windows Installer command-line options are not case-sensitive. For more information about msiexec command-line options, see Related Topics.

Related Topics


Repair a package using the command line

Microsoft Windows graphic

To repair a package using the command line

  1. Open Command Prompt.
  2. Type:

    msiexec /f[p][o][e][d][c][a][u][m][s][v] {package | ProductCode}

    Value | Description
    /fp | Reinstalls only if the file is missing.
    /fo | Reinstalls if the file is missing or if an older version is installed.
    /fe | Reinstalls if the file is missing or an equal or older version is installed.
    /fd | Reinstalls if the file is missing or a different version is installed.
    /fc | Reinstalls if the file is missing or the stored checksum does not match the calculated value.
    /fa | Forces all of the files to be reinstalled.
    /fu | Rewrites all of the required user-specific registry entries.
    /fm | Rewrites all of the required computer-specific registry entries.
    /fs | Overwrites all of the existing shortcuts.
    /fv | Runs from source and recaches the local package.
    package | Specifies the name of the Windows Installer package file.
    ProductCode | Specifies the globally unique identifier (GUID) of the Windows Installer package.

Notes

  • XOX
  • The default parameter for this command-line option is /fpecms.
  • Windows Installer command-line options are not case-sensitive. For more information about msiexec command-line options, see Related Topics.

Related Topics


Advertise a package using the command line

Microsoft Windows graphic

To advertise a package using the command line

  1. Open Command Prompt.
  2. Type:

    msiexec /j{u | m} package

    Value | Description
    /j | Advertises a product. This command-line option ignores any property values entered on the command line.
    u | Advertises to the current user.
    m | Advertises to all users of this computer.
    package | Specifies the name of the Windows Installer package file.

Notes

  • XOX
  • If you want to install the application with elevated privileges, use the /jm command-line option.
  • Windows Installer command-line options are not case-sensitive. For more information about msiexec command-line options, see Related Topics.

Related Topics


Create an administrative installation package from the command line

Microsoft Windows graphic

To create an administrative installation package from the command line

  1. Open Command Prompt.
  2. Type:

    msiexec /a package

    Value | Description
    /a | Applies the administrative installation option.
    package | Specifies the name of the Windows Installer package file.

Notes

  • XOX
  • Windows Installer command-line options are not case-sensitive. For more information about msiexec command-line options, see Related Topics.

Related Topics


Create an installation log file using the command line

Microsoft Windows graphic

To create an installation log file using the command line

  1. Open Command Prompt.
  2. Type:

    msiexec /i package /L [i][w][e][a][r][u][c][m][p][v][+][!][*] LogFile.txt

    Value | Description
    /i | Installs a product.
    package | Specifies the name of the Windows Installer package.
    /L | Indicates to log information.
    /Li | Logs status messages.
    /Lw | Logs nonfatal warnings.
    /Le | Logs all error messages.
    /La | Logs start up of actions.
    /Lr | Logs action-specific records.
    /Lu | Logs user requests.
    /Lc | Logs initial user interface parameters.
    /Lm | Out-of-memory.
    /Lp | Logs Terminal properties.
    /Lv | Specifies verbose output.
    /L+ | Appends log to the existing file.
    /L! | Flushes each line to the log.
    /L* | Wildcard. Logs all information except for the v command-line option.
    LogFile.txt | Specifies the name and path of the text log file.

Notes

  • XOX
  • Windows Installer command-line options are not case-sensitive. For more information about msiexec command-line options, see Related Topics.
  • To include the v option in a log file using the wildcard flag, type /L*v at the command prompt.
  • The Windows Installer log file options can also be used with the uninstall and repair processes.

Related Topics


Configure Group Policy for Windows Installer

  • Configure Windows Installer Group Policy computer options
  • Configure Windows Installer Group Policy user options


Configure Windows Installer Group Policy computer options

Microsoft Windows graphic

To configure Windows Installer Group Policy computer options

  1. Open Group Policy.
  2. In the console tree, click the Windows Installer node.

    3. Where?

    • applicable policy name
    • Computer Configuration
    • Administrative Templates
    • Windows Components
    • Windows Installer
  3. In the details window, double-click one of the following policy settings:
    • Disable Windows Installer
    • Always install with elevated privileges
    • Prohibit rollback
    • Remove browse dialog box for new source
    • Prohibit patching
    • Disable IE security prompt for Windows Installer scripts
    • Enable user control over installs
    • Enable user to browse for source while elevated
    • Enable user to use media source while elevated
    • Enable user to patch elevated products
    • Allow admin to install from Terminal Services session
    • Cache transforms in secure location on workstation
    • Logging
    • Prohibit User Installs
    • Turn off creation of System Restore Checkpoints
  4. In the Group Policy Property dialog box, set the options you want to use, and then click OK.

Notes

  • To open Group Policy to edit the local Group Policy object, click Start, click Run, type gpedit.msc, and then press ENTER.
  • For more information about Windows Installer Group Policy options, see Related Topics.

Related Topics


Configure Windows Installer Group Policy user options

Microsoft Windows graphic

To configure Windows Installer Group Policy user options

  1. Open Group Policy.
  2. In the console tree, click the Windows Installer node.

    3. Where?

    • applicable policy name
    • User Configuration
    • Administrative Templates
    • Windows Components
    • Windows Installer
  3. In the details window, double-click one of the following policy settings:
    • Always install with elevated privileges
    • Search order
    • Prohibit rollback
    • Prevent removable media source for any install
  4. In the Group Policy Property dialog box, set the options you want to use, and then click OK.

Notes

  • To open Group Policy to edit the local Group Policy object, click Start, click Run, type gpedit.msc, and then press ENTER.
  • For more information about Windows Installer Group Policy options, see Related Topics.

Related Topics


Concepts

This section provides general background information about Windows Installer:

  • Windows Installer overview
  • Understanding Windows Installer
  • Using Windows Installer


Windows Installer overview

Windows Installer is a component of the Windows operating system that simplifies the application installation process.

Windows Installer manages the installation and removal of applications by applying a set of centrally defined setup rules during the installation process. You can also use this service to modify, repair, or remove an existing application. Windows Installer technology consists of the Windows Installer service for the Windows operating systems and the package (.msi) file format that contains information about application set up and installation.

Windows Installer is also an extensible software management system. It manages the installation, addition, and deletion of software components, monitors file resiliency, and maintains basic failure recovery with rollbacks. Windows Installer supports installing and running software from multiple sources, and developers can customize Windows Installer to install custom applications.


Understanding Windows Installer

This section covers:

  • Windows Installer features
  • Windows Installer technologies


Windows Installer features

With Windows Installer and the .msi package file format, software installation and removal are more reliable and resilient. Windows Installer also provides a larger set of installation options. Windows Installer performs the following tasks:

  • Restores original computer state upon installation failure—Windows Installer keeps track of all changes made to the system during the application installation process. If the installation fails, Windows Installer can restore, or roll back, the system to its initial state.
  • Helps prevent interapplication conflicts—Windows Installer enforces installation rules that help to prevent conflicts with shared resources between existing applications. Such conflicts can be caused when an install operation makes updates to a dynamic link library (.dll) shared by an existing application or when an operation deletes a .dll shared by another application.
  • Reliably removes existing programs—Windows Installer can reliably uninstall any program it previously installed. It removes all of the associated registry entries and application files, except for those shared by other installed software. You can uninstall an application at any time after a successful installation. (Removal should not be confused with rollback, which restores a computer to its initial state when an installation failure has occurred.)
  • Diagnoses and repairs corrupted applications—An application can query Windows Installer to determine whether an installed application has missing or corrupted files. If any are detected, Windows Installer repairs the application by recopying only those files found to be missing or corrupted.
  • Supports on-demand installation of application features—Windows Installer can be configured to initially install a minimal subset of an application. Later, additional components can be automatically installed the first time the user accesses features that require those components. This is known as advertising. For example, Windows Installer could install Microsoft Word with a minimal set of features. The first time the user tried to access a mail merge function (not included with the original installation), Windows Installer would automatically install the mail merge component. Similarly, Windows Installer can also purge components that go unused in an application. For example, Windows Installer could be configured to remove the mail merge component if it goes unused for 60 days.
  • Supports unattended application installation—Installation packages can be configured to require no installation process interaction from the user. During the installation process, Windows Installer can query the computer for desktop attributes, including determining whether any applications were previously installed by Windows Installer.
  • Supports 32-bit and 64-bit applications—32-bit applications can be installed on 64-bit machines.
  • Supports Microsoft .NET Framework—The Microsoft .NET Framework is a new platform for building integrated, service-oriented applications that gather information from and interact with a wide variety of sources, regardless of the platforms or languages in use. The .NET Framework and the common language runtime can deliver write-once, compile-once, run-anywhere application development. Specifically, the .NET Framework delivers code reuse, code specialization, resource management, multilanguage development, security, deployment, and administration.
  • Integrated with side-by-side components—This feature eliminates .dll version conflicts by permitting an application to be bound to the version of the component it was designed and tested with, regardless of the computer that hosts the application. Side-by-side components support the simultaneous execution of multiple versions of each component.
  • Integrated with software restriction policies—This feature provides virus protection support, including protection from Trojan horse viruses and worms propagated through e-mail and the Web. Software restriction policies make the simple, point-and-click, active context user experience safe. Group Policy implements them as part of the list of trusted applications, and Windows Installer operates with applications permitted by these software restriction policies.


Windows Installer technologies

Windows Installer technologies are divided into two parts that work in combination: a client-side installer service (Msiexec.exe) and a package file (.msi file). Windows Installer uses the information contained within a package file to install the application. Following are the Windows Installer technologies:

  • Installer service—Windows Installer is an operating system service that allows the operating system to manage the installation process.
  • Installer program—The Msiexec.exe program is a component of Windows Installer. This program uses a dynamic link library, Msi.dll, to read the package files (.msi), apply transforms (.mst), and incorporate command-line options. The installer performs all installation-related tasks: copying files onto the hard disk, making registry modifications, creating shortcuts on the desktop, and displaying dialog boxes to query user installation preferences when necessary.

    When Windows Installer is installed on a computer, the file association capabilities of the operating system are modified to recognize the .msi file type. When a user double-clicks a file with the .msi extension, the operating system associates the .msi file with Windows Installer and runs the Msiexec.exe application.

  • Installation package file—Each package (.msi) file contains a relational type database that stores all the instructions and data required to install (and uninstall) the program across many installation scenarios. For example, a package file could contain instructions for installing an application when a prior version of the application is already installed. The package file could also contain instructions for installing the software on a computer where that application has never been present.
  • Transforms—The installation process can be manipulated by applying transforms (.mst) to the installation database. A transform makes changes to elements of the database. For example, Windows Installer can use a transform file to change the language in the user interface of an application. The Windows Installer transform files modify the installation package file at installation time, and can therefore dynamically affect the installation behavior.

    If you are using Group Policy Software Installation, you should note that a transform is applied at the time of assignment or publication, in addition to the time of installation. In practical terms, this means that you should ensure the Modifications tab of the package properties dialog box is set up the way you want it to be before clicking OK. If you neglect to do this and deploy an incorrectly transformed package, then you either have to remove the software and redeploy it, or upgrade the software with a correctly transformed version.

    Customization transforms, much like patches, remain cached on the computer. These transforms are applied to the base package file whenever Windows Installer needs to perform a configuration change to the installation package. Transforms are applied only at initial installation; they cannot be applied to an application that has already been installed.


Using Windows Installer

This section covers:

  • Windows Installer in managed environments
  • Msiexec (command-line options)
  • Managing options for computers through Group Policy
  • Managing options for users through Group Policy


Windows Installer in managed environments

Windows Installer is an integral part of IntelliMirror, and a core component of the Group Policy-based change and configuration management technology. By using the IntelliMirror technologies, Group Policy, and change and configuration management, administrators can approve certain applications, specifying that all configuration operations on those applications (installation, removal, and repair) run as the local system account. The administrator has control and management of the file system and registry, and Windows Installer performs user-initiated software installations. Only applications that are approved by the administrator run with elevated privileges. For more information about Windows Installer, see Using Windows Installer.

Administrators use Active Directory, IntelliMirror, and Group Policy to assign and publish applications to groups of users or computers within the enterprise. Active Directory is a secure, distributed, partitioned, and replicated directory service that provides management services. These services include a standardized method of locating resources within the enterprise, and applying Group Policy to objects managed by Active Directory. For more information about Active Directory, see Active Directory.


Managing options for computers through Group Policy

Windows Installer can be configured by using Group Policy and Active Directory to manage the computer installation options.

The following table shows policies concerned with managing the Group Policy computer options for Windows Installer. To configure these policies, start Group Policy, then in the console tree, click the Windows Installer node.

Where?

  • applicable policy name
  • Computer Configuration
  • Administrative Templates
  • Windows Installer
Policy Details
Disable Windows Installer Disables or restricts the use of Windows Installer.

This policy can prevent users from installing software on their system, or permit users to install only those programs offered by an administrator.

If you enable this policy, you can use the options in the Disable Windows Installer dialog box to establish an installation policy.

  • Never—Windows Installer is fully enabled. Users can install and upgrade software. Windows Installer is enabled by default in Windows.
  • For non-managed apps only—Users can install only those programs that an administrator assigns (offers on the desktop) or publishes (adds to Add or Remove Programs).
  • Always—Windows Installer is disabled.

Note

  • This policy affects Windows Installer only. It does not prevent users from using other methods to install and upgrade programs.
Always install with elevated privileges Directs Windows Installer to use system permissions when it installs any program on the system.

This policy extends to all programs the elevated privileges usually reserved for programs that have been assigned to the user (offered on the desktop) or the computer (installed automatically), or made available in Add or Remove Programs in Control Panel. This policy lets users install programs that require access to directories that the user might not have permission to view or change, including directories on highly restricted computers.

If you disable this policy, or do not configure it, the system applies the current user's permissions when it installs programs that are not distributed or offered by an administrator.

Note

  • This policy appears in both the Computer Configuration and User Configuration folders. To make this policy effective, you must enable the policy in both folders.
Prohibit rollback Prohibits Windows Installer from generating and saving the files it needs to reverse an interrupted or unsuccessful installation.

Prohibit rollback also prevents Windows Installer from recording the original state of the system and frequency of changes it makes during installation, and prevents Windows Installer from retaining files it intends to delete later. As a result, Windows Installer cannot restore the computer to its original state if the installation does not complete.

This policy is designed to reduce the amount of temporary disk space required to install programs. Prohibit rollback also prevents malicious users from interrupting an installation to gather data about the internal state of the computer or to search secure system files. However, because an incomplete installation can render the system or a program inoperable, do not use this policy unless essential.

This policy appears in both the Computer Configuration and User Configuration folders. To make this policy effective, you must enable the policy in both folders.
Remove browse dialog box for new source Prevents users from searching for installation files when adding features or components to an installed program.

This policy disables the Browse button next to the Use feature from list in the Windows Installer dialog box. Users must select an installation file source from the Use features from list configured by the administrator.

This policy applies even when the installation is running in the user's security context.

If you disable this policy or do not configure it, the Browse button is enabled when an installation is running in the user's security context, but only administrators can browse when an installation is running with elevated system privileges, such as installations offered on the desktop or in Add or Remove Programs.

This policy affects Windows Installer only. It does not prevent users from using other browsers, such as Windows Explorer or My Network Places, to search for installation files.
Prohibit patching Prevents users from installing patches to upgrade their programs.

Patches are updates or upgrades that replace only those program files that have changed. Because patches can be easy vehicles for malicious programs, some installations prohibit their use.

This policy applies only to installations that run in the user's security context. By default, users who are not administrators cannot apply patches to installations that run with elevated system privileges, such as those offered on the desktop or in Add or Remove Programs.
Disable IE security prompt for Windows Installer scripts Allows Web-based programs to install software on the computer without notifying the user.

By default, when a script hosted by an Internet browser attempts to install a program on the system, the system warns the user and prompts the user to either allow or refuse the installation. This policy suppresses the warning and allows the installation to proceed without user intervention.

This policy is designed for enterprises that use Web-based tools to distribute programs to their employees. However, because it might pose a security risk, it should be applied cautiously.
Enable user control over installs Permits users to change installation options that typically are available only to administrators.

This policy bypasses some of the security features of Windows Installer. It permits installations to complete that otherwise would be halted due to a security violation.

The security features of Windows Installer prevent users from changing installation options that are typically reserved for administrators, such as specifying the directory to which files are installed. If Windows Installer detects that an installation package has permitted the user to change a protected option, it stops the installation and displays an error message. These security features operate only when the installation program is running in a privileged security context in which the installation program has access to directories that are denied to the user.

This policy is designed for less restrictive environments. It can be used to circumvent errors in an installation program that prevent software from being installed.
Enable user to browse for source while elevated Permits users to search for installation files during privileged installations.

This policy enables the Browse button on the Use feature from dialog box. Users can search for installation files, even when the installation program is running, with elevated system privileges. By default, only system administrators can browse during installations with elevated privileges, such as installations offered on the desktop or displayed in Add or Remove Programs.

Because the installation is running with elevated system privileges, users can browse through directories that their own permissions would not allow.

This policy does not affect installations that run in the user's security context. For more information, see the Remove browse dialog box for new source policy.
Enable user to use media source while elevated Permits users to install programs from removable media, such as floppy disks and CD-ROMs, during privileged installation.

This policy permits all users to install programs from removable media, even when the installation program is running with elevated system privileges. By default, users can install programs from removable media only when the installation runs in the user's security context. During privileged installations, such as those offered on the desktop or displayed in Add or Remove Programs, only system administrators can install from removable media.

This policy does not affect installations that run in the user's security context. By default, users can install from removable media when the installation runs in their own security context.

For more information, see the Prevent removable media source for any install policy in Managing options for users through Group Policy.
Enable user to patch elevated products Permits users to upgrade programs during privileged installations.

This policy permits all users to install patches, even when the installation program is running with elevated privileges. Patches are updates or upgrades that replace only those program files that have changed. Because patches can easily be vehicles for malicious programs, some installations prohibit their use.

By default, only system administrators can apply patches during installations with elevated privileges, such as installations offered on the desktop or displayed in Add or Remove Programs.

This policy does not affect installations that run in the user's security context. By default, users can install patches to programs that run in their own security context. For more information about prohibiting patch installations, see the Prohibit patching policy.
Allow admin to install from Terminal Services session Permits Terminal Services administrators to install and configure programs remotely.

By default, system administrators can install programs only when they are logged on to the computer on which the program is being installed. This policy creates a special exception for computers running Terminal Services.

This policy affects system administrators only. Other users cannot install programs remotely.
Cache transforms in secure location on workstation Copies of transform files are saved in a secure location on the local computer.

Transform files consist of instructions to modify or customize a program during installation. By default, Windows Installer stores transform files in the Application Data directory in the user's profile. When a user reinstalls, removes, or repairs an installation, the transform file is available, even if the user is on a different computer, or isn't connected to the network.

If you enable this policy, the transform file is saved in a secure location on the user's computer instead of in the user profile. Because Windows Installer requires the transform file to repeat an installation in which the transform file was used, the user must be using the same computer or be connected to the original or identical media to reinstall, remove, or repair the installation.

This policy is designed for enterprises that must take special precautions to prevent unauthorized or malicious editing of transform files.
Logging Specifies the types of events that Windows Installer records in its transaction log for each installation. The log, msi.log, appears in the systemroot\Temp directory.

To indicate that an event type is recorded, enter the letter representing the event type. You can enter the letters in any order, and list as many or as few event types as you want. To disable logging, delete all of the letters from the box. The Windows Installer logging options are listed in the following table.

Mode | Log entry
i | Status messages
w | Non-fatal warnings
e | All error messages
a | Startup of actions
r | Action-specific records
u | User requests
c | Initial user interface parameters
m | Out-of-memory
p | Terminal properties
v | Verbose output
o | Out of disk space messages

Notes

  • If you disable this policy, or do not configure it, Windows Installer logs the default event types, represented by the letters iweap.
  • You can include all possible events in the installation log file by entering iwearucmpvo. However, doing so will add considerable time to the installation process.

Prohibit User Installs Allows you to configure user installs. To configure this setting, set it to enabled and use the drop-down list to select the behavior you want.

If this setting is not configured, or if the setting is enabled and Allow User Installs is selected, the installer allows and makes use of products that are installed per user, and products that are installed per computer. If the installer finds a per-user install of an application, this hides a per-computer installation of that same product.

If this setting is enabled and Hide User Installs is selected, the installer ignores per-user applications. This causes a per-computer installed application to be visible to users, even if those users have a per-user install of the product registered in their user profile.

If this setting is enabled and Prohibit User Installs is selected, the installer prevents applications from being installed per user, and it ignores previously installed per-user applications. An attempt to perform a per-user installation causes the installer to display an error message and stop the installation. This setting is useful in environments where the administrator only wants per-computer applications installed, such as on a kiosk or a Windows Terminal Server.
Turn off creation of System Restore Checkpoints Stops Windows Installer from generating System Restore checkpoints when installing applications.

System Restore enables users, in the event of a problem, to restore their computers to a previous state without losing personal data files. By default, Windows Installer automatically creates a System Restore checkpoint each time an application is installed, so that users can restore their computer to the state it was in before installing the application.

If you disable this setting or do not configure it, Windows Installer automatically creates a System Restore checkpoint each time an application is installed.

Note

  • This setting only applies to XOX.


Managing options for users through Group Policy

Windows Installer can be configured by using Group Policy and Active Directory to manage the user installation options.

This table shows policies concerned with managing the Group Policy user options for Windows Installer. To configure these policies, start Group Policy, then in the console tree, click the Windows Installer node.

Where?

  • applicable policy name
  • User Configuration
  • Administrative Templates
  • Windows Installer
Policy Details
Always install with elevated privileges Directs Windows Installer to use system permissions when it installs any program on the system.

This policy extends to all programs the elevated privileges usually reserved for programs that have been assigned to the user (offered on the desktop) or the computer (installed automatically), or made available in Add or Remove Programs in Control Panel. This policy lets users install programs that require access to directories that the user might not have permission to view or change, including directories on highly restricted computers.

If you disable this policy, or do not configure it, the system applies the current user's permissions when it installs programs that are not distributed or offered by an administrator.

Note

  • This policy appears both in the Computer Configuration and User Configuration folders. To make this policy effective, you must enable the policy in both folders.
Search order Specifies the order in which Windows Installer searches for installation files.

By default, Windows Installer searches the network first, then removable media (floppy drive, CD-ROM, or DVD), and finally, the Internet (URL).

To change the search order, enable the policy, and then type the letters listed in the following table for each file source in the order that you want Windows Installer to search. For example, if you want to search the network, the Internet, and then removable media, type num.

Option | Media type
n | Adds the network in the source file search.
m | Adds the removable media in the source file search.
u | Adds the Internet in the source file search.

Note

  • To exclude a file source, omit or delete the letter representing that source type.
Prohibit rollback Prohibits Windows Installer from generating and saving the files it needs to reverse an interrupted or unsuccessful installation.

This policy prevents Windows Installer from recording the original state of the system and sequence of changes it makes during installation. It also prevents Windows Installer from retaining files it intends to delete later. As a result, Windows Installer cannot restore the computer to its original state if the installation does not complete.

This policy is designed to reduce the amount of temporary disk space required to install applications. It also prevents malicious users from interrupting an installation to gather data about internal state of the computer or to search secure system files. However, because an incomplete installation can render the system or an application inoperable, this policy should not be used unless it is essential.

Note

  • This policy appears in both the Computer Configuration and User Configuration folders. To make this policy effective, you must enable the policy in both folders.
Prevent removable media source for any install Prevents users from installing programs from removable media.

If a user tries to install a program from removable media, such as CD-ROMs, floppy disks, or DVDs, a message informs the user that the feature cannot be found.

This policy applies even when the installation is running in the user's security context.

If you disable or do not configure this policy, users can install from removable media when the installation is running in their own security context, but only system administrators can use removable media when an installation is running with elevated system privileges, such as installations offered on the desktop or in Add or Remove Programs.


Troubleshooting

What problem are you having?

The installation package does not install correctly.

Cause: The installation packaged has been corrupted.

Solution: Repair the installation package by using the Windows Installer repair option.

See also: To repair a package using the command line

The installation process stops before completing the installation.

Cause: Windows Installer was not able read the installation package, or conditions on your computer prevented the package from being installed successfully.

Solution: Windows Installer creates entries in the Windows event log. To view the log, do the following:

  1. Open Event Viewer.
  2. Review the application log for Windows Installer entries.

Notes

  • To open Event Viewer, click Start, point to Settings, and then click Control Panel. Double-click Administrative Tools, and then double-click Event Viewer.
  • You can configure Windows Installer to create a custom installation log file.

See also: To create an installation log file using the command line